Index: src/sas/sasgui/perspectives/fitting/model_thread.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/model_thread.py	(revision ca4d9854c75a5344e770dec25221dfeb5a270915)
+++ src/sas/sasgui/perspectives/fitting/model_thread.py	(revision 286c7571e8019b4c28a92d3d497cac7da825076c)
@@ -179,17 +179,20 @@
             unsmeared_output[first_bin:last_bin+1] = self.model.evalDistribution(mask)
             output = self.smearer(unsmeared_output, first_bin, last_bin)
-            
+
             # Rescale data to unsmeared model
-            unsmeared_data = numpy.zeros((len(self.data.x)))
-            unsmeared_error = numpy.zeros((len(self.data.x)))
-            unsmeared_data[first_bin:last_bin+1] = self.data.y[first_bin:last_bin+1]\
-                                                    * unsmeared_output[first_bin:last_bin+1]\
-                                                    / output[first_bin:last_bin+1]
-            unsmeared_error[first_bin:last_bin+1] = self.data.dy[first_bin:last_bin+1]\
-                                                    * unsmeared_output[first_bin:last_bin+1]\
-                                                    / output[first_bin:last_bin+1]
-            unsmeared_output=unsmeared_output[index]
-            unsmeared_data=unsmeared_data[index]
-            unsmeared_error=unsmeared_error
+            # Check that the arrays are compatible. If we only have a model but no data,
+            # the length of data.y will be zero.
+            if isinstance(self.data.y, numpy.ndarray) and output.shape == self.data.y.shape:
+                unsmeared_data = numpy.zeros((len(self.data.x)))
+                unsmeared_error = numpy.zeros((len(self.data.x)))
+                unsmeared_data[first_bin:last_bin+1] = self.data.y[first_bin:last_bin+1]\
+                                                        * unsmeared_output[first_bin:last_bin+1]\
+                                                        / output[first_bin:last_bin+1]
+                unsmeared_error[first_bin:last_bin+1] = self.data.dy[first_bin:last_bin+1]\
+                                                        * unsmeared_output[first_bin:last_bin+1]\
+                                                        / output[first_bin:last_bin+1]
+                unsmeared_output=unsmeared_output[index]
+                unsmeared_data=unsmeared_data[index]
+                unsmeared_error=unsmeared_error
         else:
             output[index] = self.model.evalDistribution(self.data.x[index])
Index: src/sas/sasgui/perspectives/fitting/models.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/models.py	(revision 6fb559d7e0b3729983ce407aeb8ba9c519a57907)
+++ src/sas/sasgui/perspectives/fitting/models.py	(revision 212bfc297ca102b648c949f030d3d06a4c569fa3)
@@ -412,5 +412,5 @@
     """
     __modelmanager = ModelManagerBase()
-    cat_model_list = [model_name for model_name \
+    cat_model_list = [__modelmanager.model_dictionary[model_name] for model_name \
                       in __modelmanager.model_dictionary.keys() \
                       if model_name not in __modelmanager.stored_plugins.keys()]
Index: src/sas/sasgui/perspectives/fitting/pagestate.py
===================================================================
--- src/sas/sasgui/perspectives/fitting/pagestate.py	(revision 6c382da7a67e14f0ad75317f0696ce771b802d39)
+++ src/sas/sasgui/perspectives/fitting/pagestate.py	(revision e6de6b8b31744ebe652ab6206d60d0d20979c592)
@@ -2,13 +2,13 @@
     Class that holds a fit page state
 """
-#TODO: Refactor code so we don't need to use getattr/setattr
+# TODO: Refactor code so we don't need to use getattr/setattr
 ################################################################################
-#This software was developed by the University of Tennessee as part of the
-#Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
-#project funded by the US National Science Foundation.
+# This software was developed by the University of Tennessee as part of the
+# Distributed Data Analysis of Neutron Scattering Experiments (DANSE)
+# project funded by the US National Science Foundation.
 #
-#See the license text in license.txt
+# See the license text in license.txt
 #
-#copyright 2009, University of Tennessee
+# copyright 2009, University of Tennessee
 ################################################################################
 import time
@@ -30,10 +30,7 @@
 from sas.sascalc.dataloader.readers.cansas_reader import Reader as CansasReader
 from sas.sascalc.dataloader.readers.cansas_reader import get_content, write_node
-from sas.sascalc.dataloader.data_info import Data2D
-from sas.sascalc.dataloader.data_info import Collimation
-from sas.sascalc.dataloader.data_info import Detector
-from sas.sascalc.dataloader.data_info import Process
-from sas.sascalc.dataloader.data_info import Aperture
-#Information to read/write state as xml
+from sas.sascalc.dataloader.data_info import Data2D, Collimation, Detector
+from sas.sascalc.dataloader.data_info import Process, Aperture
+# Information to read/write state as xml
 FITTING_NODE_NAME = 'fitting_plug_in'
 CANSAS_NS = "cansas1d/1.0"
@@ -123,5 +120,4 @@
             try:
                 return node.get(item[0]).strip() == "True"
-
             except:
                 return None
@@ -146,18 +142,19 @@
         """
         self.file = None
-        #Time of state creation
+        # Time of state creation
         self.timestamp = time.time()
-        ## Data member to store the dispersion object created
+        # Data member to store the dispersion object created
         self._disp_obj_dict = {}
-        #------------------------
-        #Data used for fitting
+        # ------------------------
+        # Data used for fitting
         self.data = data
         # model data
         self.theory_data = None
-        #Is 2D
+        # Is 2D
         self.is_2D = False
         self.images = None
 
-        #save additional information on data that dataloader.reader does not read
+        # save additional information on data that dataloader.reader
+        # does not read
         self.is_data = None
         self.data_name = ""
@@ -172,5 +169,5 @@
             self.data_group_id = self.data.group_id
 
-        ## reset True change the state of exsiting button
+        # reset True change the state of existing button
         self.reset = False
 
@@ -180,14 +177,14 @@
         self.model = model
         self.m_name = None
-        #list of process done to model
+        # list of process done to model
         self.process = []
-        #fit page manager
+        # fit page manager
         self.manager = None
-        #Store the parent of this panel parent
+        # Store the parent of this panel parent
         # For this application fitpanel is the parent
         self.parent = parent
         # Event_owner is the owner of model event
         self.event_owner = None
-        ##page name
+        # page name
         self.page_name = ""
         # Contains link between model, all its parameters, and panel organization
@@ -196,14 +193,14 @@
         self.str_parameters = []
         # Contains list of parameters that cannot be fitted and reference to
-        #panel objects
+        # panel objects
         self.fixed_param = []
         # Contains list of parameters with dispersity and reference to
-        #panel objects
+        # panel objects
         self.fittable_param = []
-        ## orientation parameters
+        # orientation parameters
         self.orientation_params = []
-        ## orientation parameters for gaussian dispersity
+        # orientation parameters for gaussian dispersity
         self.orientation_params_disp = []
-        ## smearer info
+        # smearer info
         self.smearer = None
         self.smear_type = None
@@ -214,5 +211,5 @@
         self.dxl = None
         self.dxw = None
-        #list of dispersion parameters
+        # list of dispersion parameters
         self.disp_list = []
         if self.model is not None:
@@ -223,27 +220,27 @@
         self.weights = {}
 
-        #contains link between a model and selected parameters to fit
+        # contains link between a model and selected parameters to fit
         self.param_toFit = []
-        ##dictionary of model type and model class
+        # dictionary of model type and model class
         self.model_list_box = None
-        ## save the state of the context menu
+        # save the state of the context menu
         self.saved_states = {}
-        ## save selection of combobox
+        # save selection of combobox
         self.formfactorcombobox = None
         self.categorycombobox = None
         self.structurecombobox = None
 
-        ## radio box to select type of model
-        #self.shape_rbutton = False
-        #self.shape_indep_rbutton = False
-        #self.struct_rbutton = False
-        #self.plugin_rbutton = False
-        ## the indice of the current selection
+        # radio box to select type of model
+        # self.shape_rbutton = False
+        # self.shape_indep_rbutton = False
+        # self.struct_rbutton = False
+        # self.plugin_rbutton = False
+        # the indice of the current selection
         self.disp_box = 0
-        ## Qrange
-        ## Q range
+        # Qrange
+        # Q range
         self.qmin = 0.001
         self.qmax = 0.1
-        #reset data range
+        # reset data range
         self.qmax_x = None
         self.qmin_x = None
@@ -253,5 +250,5 @@
         self.multi_factor = None
         self.magnetic_on = False
-        ## enable smearering state
+        # enable smearering state
         self.enable_smearer = False
         self.disable_smearer = True
@@ -263,11 +260,11 @@
         self.dI_sqrdata = False
         self.dI_idata = False
-        ## disperity selection
+        # disperity selection
         self.enable_disp = False
         self.disable_disp = True
 
-        ## state of selected all check button
+        # state of selected all check button
         self.cb1 = False
-        ## store value of chisqr
+        # store value of chisqr
         self.tcChi = None
 
@@ -293,8 +290,8 @@
         obj.structurecombobox = self.structurecombobox
 
-        #obj.shape_rbutton = self.shape_rbutton
-        #obj.shape_indep_rbutton = self.shape_indep_rbutton
-        #obj.struct_rbutton = self.struct_rbutton
-        #obj.plugin_rbutton = self.plugin_rbutton
+        # obj.shape_rbutton = self.shape_rbutton
+        # obj.shape_indep_rbutton = self.shape_indep_rbutton
+        # obj.struct_rbutton = self.struct_rbutton
+        # obj.plugin_rbutton = self.plugin_rbutton
 
         obj.manager = self.manager
@@ -381,10 +378,12 @@
 
         rep += "State created: %s\n" % time_str
-        rep += "State form factor combobox selection: %s\n" % self.formfactorcombobox
-        rep += "State structure factor combobox selection: %s\n" % self.structurecombobox
+        rep += "State form factor combobox selection: %s\n" % \
+               self.formfactorcombobox
+        rep += "State structure factor combobox selection: %s\n" % \
+               self.structurecombobox
         rep += "is data : %s\n" % self.is_data
         rep += "data's name : %s\n" % self.data_name
         rep += "data's id : %s\n" % self.data_id
-        if self.model != None:
+        if self.model is not None:
             m_name = self.model.__class__.__name__
             if m_name == 'Model':
@@ -397,6 +396,6 @@
         rep += "model type (Category) selected: %s\n" % self.categorycombobox
         rep += "data : %s\n" % str(self.data)
-        rep += "Plotting Range: min: %s, max: %s, steps: %s\n" % (str(self.qmin),
-                                                                  str(self.qmax), str(self.npts))
+        rep += "Plotting Range: min: %s, max: %s, steps: %s\n" % \
+               (str(self.qmin),str(self.qmax), str(self.npts))
         rep += "Dispersion selection : %s\n" % str(self.disp_box)
         rep += "Smearing enable : %s\n" % str(self.enable_smearer)
@@ -414,8 +413,8 @@
 
         rep += "2D enable : %s\n" % str(self.enable2D)
-        rep += "All parameters checkbox selected: %s\n" % (self.cb1)
+        rep += "All parameters checkbox selected: %s\n" % str(self.cb1)
         rep += "Value of Chisqr : %s\n" % str(self.tcChi)
         rep += "Smear object : %s\n" % str(self.smearer)
-        rep += "Smear type : %s\n" % (self.smear_type)
+        rep += "Smear type : %s\n" % str(self.smear_type)
         rep += "dq_l  : %s\n" % self.dq_l
         rep += "dq_r  : %s\n" % self.dq_r
@@ -434,8 +433,8 @@
             if not self.is_2D:
                 for item in self.parameters:
-                    if not item in self.orientation_params:
+                    if item not in self.orientation_params:
                         temp_parameters.append(item)
                 for item in self.fittable_param:
-                    if not item in self.orientation_params_disp:
+                    if item not in self.orientation_params_disp:
                         temp_fittable_param.append(item)
             else:
@@ -443,9 +442,12 @@
                 temp_fittable_param = self.fittable_param
 
-            rep += "number parameters(self.parameters): %s\n" % len(temp_parameters)
+            rep += "number parameters(self.parameters): %s\n" % \
+                   len(temp_parameters)
             rep = self._repr_helper(list=temp_parameters, rep=rep)
-            rep += "number str_parameters(self.str_parameters): %s\n" % len(self.str_parameters)
+            rep += "number str_parameters(self.str_parameters): %s\n" % \
+                   len(self.str_parameters)
             rep = self._repr_helper(list=self.str_parameters, rep=rep)
-            rep += "number fittable_param(self.fittable_param): %s\n" % len(temp_fittable_param)
+            rep += "number fittable_param(self.fittable_param): %s\n" % \
+                   len(temp_fittable_param)
             rep = self._repr_helper(list=temp_fittable_param, rep=rep)
         return rep
@@ -551,5 +553,6 @@
                     paramval_string += CENTRE % param + "\n"
 
-        text_string = "\n\n\n%s\n\n%s\n%s\n%s\n\n%s" % (title, file, q_name, chi2, paramval)
+        text_string = "\n\n\n%s\n\n%s\n%s\n%s\n\n%s" % \
+                      (title, file, q_name, chi2, paramval)
 
         title_name = self._check_html_format(title_name)
@@ -632,16 +635,17 @@
             element.appendChild(sub_element)
 
-    def toXML(self, file="fitting_state.fitv", doc=None, entry_node=None):
-        """
-        Writes the state of the InversionControl panel to file, as XML.
+    def toXML(self, file="fitting_state.fitv", doc=None,
+              entry_node=None, batch_fit_state=None):
+        """
+        Writes the state of the fit panel to file, as XML.
 
         Compatible with standalone writing, or appending to an
-        already existing XML document. In that case, the XML document
-        is required. An optional entry node in the XML document may also be given.
+        already existing XML document. In that case, the XML document is
+        required. An optional entry node in the XML document may also be given.
 
         :param file: file to write to
         :param doc: XML document object [optional]
-        :param entry_node: XML node within the XML document at which we will append the data [optional]
-
+        :param entry_node: XML node within the XML document at which we
+                           will append the data [optional]
         """
         from xml.dom.minidom import getDOMImplementation
@@ -691,4 +695,5 @@
         element.setAttributeNode(attr)
         top_element.appendChild(element)
+
         # Inputs
         inputs = newdoc.createElement("Attributes")
@@ -741,6 +746,56 @@
         for item in LIST_OF_STATE_PARAMETERS:
             element = newdoc.createElement(item[0])
-            self._toXML_helper(thelist=getattr(self, item[1]), element=element, newdoc=newdoc)
+            self._toXML_helper(thelist=getattr(self, item[1]),
+                               element=element, newdoc=newdoc)
             inputs.appendChild(element)
+
+        # Combined and Simultaneous Fit Parameters
+        if batch_fit_state is not None:
+            batch_combo = newdoc.createElement('simultaneous_fit')
+            top_element.appendChild(batch_combo)
+
+            # Simultaneous Fit Number For Linking Later
+            element = newdoc.createElement('sim_fit_number')
+            element.setAttribute('fit_number', str(batch_fit_state.fit_page_no))
+            batch_combo.appendChild(element)
+
+            # Save constraints
+            constraints = newdoc.createElement('constraints')
+            batch_combo.appendChild(constraints)
+            for constraint in batch_fit_state.constraints_list:
+                if constraint.model_cbox.GetValue() != "":
+                    # model_cbox, param_cbox, egal_txt, constraint, btRemove, sizer
+                    doc_cons = newdoc.createElement('constraint')
+                    doc_cons.setAttribute('model_cbox',
+                                          str(constraint.model_cbox.GetValue()))
+                    doc_cons.setAttribute('param_cbox',
+                                          str(constraint.param_cbox.GetValue()))
+                    doc_cons.setAttribute('egal_txt',
+                                          str(constraint.egal_txt.GetLabel()))
+                    doc_cons.setAttribute('constraint',
+                                          str(constraint.constraint.GetValue()))
+                    constraints.appendChild(doc_cons)
+
+            # Save all models
+            models = newdoc.createElement('model_list')
+            batch_combo.appendChild(models)
+            for model in batch_fit_state.model_list:
+                doc_model = newdoc.createElement('model_list_item')
+                doc_model.setAttribute('checked', str(model[0].GetValue()))
+                keys = model[1].keys()
+                doc_model.setAttribute('name', str(keys[0]))
+                values = model[1].get(keys[0])
+                doc_model.setAttribute('fit_number', str(model[2]))
+                doc_model.setAttribute('fit_page_source', str(model[3]))
+                doc_model.setAttribute('model_name', str(values.model.id))
+                models.appendChild(doc_model)
+
+            # Select All Checkbox
+            element = newdoc.createElement('select_all')
+            if batch_fit_state.select_all:
+                element.setAttribute('checked', 'True')
+            else:
+                element.setAttribute('checked', 'False')
+            batch_combo.appendChild(element)
 
         # Save the file
@@ -809,5 +864,4 @@
         :param file: .fitv file
         :param node: node of a XML document to read from
-
         """
         if file is not None:
@@ -816,5 +870,5 @@
             raise RuntimeError, msg
 
-        if node.get('version')and node.get('version') == '1.0':
+        if node.get('version') and node.get('version') == '1.0':
 
             # Get file name
@@ -862,6 +916,6 @@
                                 value = cls.type
                             except Exception:
-                                logging.error("unable to load distribution %r for %s"
-                                              % (value, parameter))
+                                base = "unable to load distribution %r for %s"
+                                logging.error(base % (value, parameter))
                                 continue
                         _disp_obj_dict = getattr(self, varname)
@@ -960,4 +1014,6 @@
         self.cansas = cansas
         self.state = None
+        # batch fitting params for saving
+        self.batchfit_params = []
 
     def get_state(self):
@@ -984,11 +1040,13 @@
             raise RuntimeError, "The cansas writer expects a Data2D instance"
 
+        title = "cansas1d/%s" % self.version
+        title += "http://svn.smallangles.net/svn/canSAS/1dwg/trunk/cansas1d.xsd"
         doc = xml.dom.minidom.Document()
         main_node = doc.createElement("SASroot")
         main_node.setAttribute("version", self.version)
         main_node.setAttribute("xmlns", "cansas1d/%s" % self.version)
-        main_node.setAttribute("xmlns:xsi", "http://www.w3.org/2001/XMLSchema-instance")
-        main_node.setAttribute("xsi:schemaLocation",
-                               "cansas1d/%s http://svn.smallangles.net/svn/canSAS/1dwg/trunk/cansas1d.xsd" % self.version)
+        main_node.setAttribute("xmlns:xsi",
+                               "http://www.w3.org/2001/XMLSchema-instance")
+        main_node.setAttribute("xsi:schemaLocation", title)
 
         doc.appendChild(main_node)
@@ -999,8 +1057,10 @@
         write_node(doc, entry_node, "Title", datainfo.title)
         if datainfo is not None:
-            write_node(doc, entry_node, "data_class", datainfo.__class__.__name__)
+            write_node(doc, entry_node, "data_class",
+                       datainfo.__class__.__name__)
         for item in datainfo.run:
             runname = {}
-            if datainfo.run_name.has_key(item) and len(str(datainfo.run_name[item])) > 1:
+            if datainfo.run_name.has_key(item) and \
+                            len(str(datainfo.run_name[item])) > 1:
                 runname = {'name': datainfo.run_name[item]}
             write_node(doc, entry_node, "Run", item, runname)
@@ -1219,5 +1279,4 @@
 
         :param entry: XML node to read from
-
         :return: PageState object
         """
@@ -1228,5 +1287,5 @@
             nodes = entry.xpath('ns:%s' % FITTING_NODE_NAME,
                                 namespaces={'ns': CANSAS_NS})
-            if nodes != []:
+            if nodes:
                 # Create an empty state
                 state = PageState()
@@ -1238,4 +1297,44 @@
 
         return state
+
+    def _parse_simfit_state(self, entry):
+        """
+        Parses the saved data for a simultaneous fit
+        :param entry: XML object to read from
+        :return: XML object for a simultaneous fit or None
+        """
+        nodes = entry.xpath('ns:%s' % FITTING_NODE_NAME,
+                            namespaces={'ns': CANSAS_NS})
+        if nodes:
+            simfitstate = nodes[0].xpath('ns:simultaneous_fit',
+                                         namespaces={'ns': CANSAS_NS})
+            if simfitstate:
+                from simfitpage import SimFitPageState
+                sim_fit_state = SimFitPageState()
+                simfitstate_0 = simfitstate[0]
+                all = simfitstate_0.xpath('ns:select_all',
+                                        namespaces={'ns': CANSAS_NS})
+                atts = all[0].attrib
+                checked = atts.get('checked')
+                sim_fit_state.select_all = bool(checked)
+                model_list = simfitstate_0.xpath('ns:model_list',
+                                               namespaces={'ns': CANSAS_NS})
+                model_list_items = model_list[0].xpath('ns:model_list_item',
+                                                   namespaces={'ns': CANSAS_NS})
+                for model in model_list_items:
+                    attrs = model.attrib
+                    sim_fit_state.model_list.append(attrs)
+
+                constraints = simfitstate_0.xpath('ns:constraints',
+                                                namespaces={'ns': CANSAS_NS})
+                constraint_list = constraints[0].xpath('ns:constraint',
+                                               namespaces={'ns': CANSAS_NS})
+                for constraint in constraint_list:
+                    attrs = constraint.attrib
+                    sim_fit_state.constraints_list.append(attrs)
+
+                return sim_fit_state
+            else:
+                return None
 
     def _parse_save_state_entry(self, dom):
@@ -1298,5 +1397,6 @@
                         data_info.notes.append(note_value)
             except Exception:
-                err_mess = "cansas_reader.read: error processing entry notes\n  %s" % sys.exc_value
+                err_mess = "cansas_reader.read: error processing entry notes\n"
+                err_mess += "  %s" % sys.exc_value
                 self.errors.append(err_mess)
                 logging.error(err_mess)
@@ -1308,9 +1408,13 @@
 
         self._store_content('ns:SASsample/ns:ID', dom, 'ID', data_info.sample)
-        self._store_float('ns:SASsample/ns:thickness', dom, 'thickness', data_info.sample)
-        self._store_float('ns:SASsample/ns:transmission', dom, 'transmission', data_info.sample)
-        self._store_float('ns:SASsample/ns:temperature', dom, 'temperature', data_info.sample)
-
-        nodes = dom.xpath('ns:SASsample/ns:details', namespaces={'ns': CANSAS_NS})
+        self._store_float('ns:SASsample/ns:thickness', dom, 'thickness',
+                          data_info.sample)
+        self._store_float('ns:SASsample/ns:transmission', dom, 'transmission',
+                          data_info.sample)
+        self._store_float('ns:SASsample/ns:temperature', dom, 'temperature',
+                          data_info.sample)
+
+        nodes = dom.xpath('ns:SASsample/ns:details',
+                          namespaces={'ns': CANSAS_NS})
         for item in nodes:
             try:
@@ -1320,12 +1424,16 @@
                         data_info.sample.details.append(detail_value)
             except Exception:
-                err_mess = "cansas_reader.read: error processing sample details\n  %s" % sys.exc_value
+                err_mess = "cansas_reader.read: error processing entry notes\n"
+                err_mess += "  %s" % sys.exc_value
                 self.errors.append(err_mess)
                 logging.error(err_mess)
 
         # Position (as a vector)
-        self._store_float('ns:SASsample/ns:position/ns:x', dom, 'position.x', data_info.sample)
-        self._store_float('ns:SASsample/ns:position/ns:y', dom, 'position.y', data_info.sample)
-        self._store_float('ns:SASsample/ns:position/ns:z', dom, 'position.z', data_info.sample)
+        self._store_float('ns:SASsample/ns:position/ns:x', dom, 'position.x',
+                          data_info.sample)
+        self._store_float('ns:SASsample/ns:position/ns:y', dom, 'position.y',
+                          data_info.sample)
+        self._store_float('ns:SASsample/ns:position/ns:z', dom, 'position.z',
+                          data_info.sample)
 
         # Orientation (as a vector)
@@ -1461,5 +1569,6 @@
                         process.term.append(term_attr)
                 except:
-                    err_mess = "cansas_reader.read: error processing process term\n  %s" % sys.exc_value
+                    err_mess = "cansas_reader.read: error processing "
+                    err_mess += "entry notes\n  %s" % sys.exc_value
                     self.errors.append(err_mess)
                     logging.error(err_mess)
@@ -1476,5 +1585,6 @@
         nodes = dom.xpath('ns:SASdata', namespaces={'ns': CANSAS_NS})
         if len(nodes) > 1:
-            raise RuntimeError, "CanSAS reader is not compatible with multiple SASdata entries"
+            raise RuntimeError, "CanSAS reader is not compatible with" + \
+                                " multiple SASdata entries"
 
         for entry in nodes:
@@ -1488,5 +1598,6 @@
                 value_list = []
                 if field is not None:
-                    value_list = [parse_entry_helper(node, item) for node in field]
+                    value_list = \
+                        [parse_entry_helper(node, item) for node in field]
                 if len(value_list) < 2:
                     setattr(data_info, item[0], None)
@@ -1498,17 +1609,15 @@
     def _read_cansas(self, path):
         """
-        Load data and P(r) information from a CanSAS XML file.
+        Load data and fitting information from a CanSAS XML file.
 
         :param path: file path
-
         :return: Data1D object if a single SASentry was found,
                     or a list of Data1D objects if multiple entries were found,
                     or None of nothing was found
-
         :raise RuntimeError: when the file can't be opened
         :raise ValueError: when the length of the data vectors are inconsistent
-
         """
         output = []
+        simfitstate = None
         basename = os.path.basename(path)
         root, extension = os.path.splitext(basename)
@@ -1516,16 +1625,13 @@
         try:
             if os.path.isfile(path):
-
-                #TODO: eventually remove the check for .xml once
-                # the P(r) writer/reader is truly complete.
-                if  ext in self.ext or \
-                    ext == '.xml':
-
+                if ext in self.ext or ext == '.xml':
                     tree = etree.parse(path, parser=etree.ETCompatXMLParser())
                     # Check the format version number
-                    # Specifying the namespace will take care of the file format version
+                    # Specifying the namespace will take care of the file
+                    # format version
                     root = tree.getroot()
                     entry_list = root.xpath('ns:SASentry',
                                             namespaces={'ns': CANSAS_NS})
+                    name_map = {}
                     for entry in entry_list:
                         try:
@@ -1535,10 +1641,11 @@
                         fitstate = self._parse_state(entry)
 
-                        #state could be None when .svs file is loaded
-                        #in this case, skip appending to output
-                        if fitstate != None:
+                        # state could be None when .svs file is loaded
+                        # in this case, skip appending to output
+                        if fitstate is not None:
                             sas_entry.meta_data['fitstate'] = fitstate
                             sas_entry.filename = fitstate.file
                             output.append(sas_entry)
+
             else:
                 self.call_back(format=ext)
@@ -1580,8 +1687,12 @@
                         name = original_fname
                     state.data.group_id = name
-                    #store state in fitting
+                    # store state in fitting
                     self.call_back(state=state,
                                    datainfo=output[ind], format=ext)
                     self.state = state
+                simfitstate = self._parse_simfit_state(entry)
+                if simfitstate is not None:
+                    self.call_back(state=simfitstate)
+
                 return output
         except:
@@ -1599,5 +1710,5 @@
         """
         # Sanity check
-        if self.cansas == True:
+        if self.cansas:
             # Add fitting information to the XML document
             doc = self.write_toXML(datainfo, fitstate)
@@ -1611,5 +1722,5 @@
         fd.close()
 
-    def write_toXML(self, datainfo=None, state=None):
+    def write_toXML(self, datainfo=None, state=None, batchfit=None):
         """
         Write toXML, a helper for write(),
